<?php

session_start();
if ((isset($_SESSION['beroari_username']))&&(($_SESSION['beroari_time']+1200)>time())){
	$_SESSION['beroari_time']=time();

	include "./includes/variables.php";
	include "misc/database.php";
	include "./includes/check.php";	
	
	
	include "includes/variables.php";
	include "includes/Sqlite/Tools.php";
	
	include "includes/password_func.php";
	include "modules/sip.php";
	include "modules/sip_general.php";
	include "modules/isdn.php";
	include "modules/analog.php";
	include "modules/pstn_hw.php";
	include "modules/net_conf.php";
	include "modules/time_conf.php";
	include "modules/dialplan.php";
	include "modules/general.php";
	include "modules/security.php";
	include "modules/update_tool.php";
	include "modules/provisioning.php";
	include "modules/state.php";
	include "modules/state_calls.php";
	include "modules/state_statistic.php";
	include "modules/berofos.php";
	include "modules/info.php";
	include "modules/cdr.php";
	include "modules/causes.php";
	include "modules/callprogress.php";
	include "modules/remoteManagement.php";
	
	//Wenn der Benutzer beroAdmin ist, wird der Shell Modul eingeblendet
	if ($_SESSION['beroari_username']=="beroAdmin"){
		include "modules/shell.php";
		
		$sh=new Shell();
		if ($_GET['m']=="shell")  
		print $sh->display("m=shell,f=display,a=display");
	}
	include "modules/rebres.php";
	include "modules/ddebug.php";
	include "modules/ftrace.php";
	include "modules/back_res.php";

	//Verschiedene Module instanziieren
	$remoteM=new remoteManagement();
	$e = new Dialplan();
	$sip= new Sip();
	$sipg = new Sip_general();
	$isdn = new Isdn();
	$analog = new Analog();
	$p_hw = new Pstn_hw();
	$net = new Net_conf();
	$time = new Time_conf();
	$gen= new General();
	$causes= new Isgw_causes();
	$callprogress= new Call_progress();
	$sec= new Sec();
	$up_tool= new Up_tool();
	$prov= new Provisioning();
	$state=new State();
	$sc=new State_calls();
	$ss=new State_Statistic();
	$ddebug=new Dialplandebug();
	$ftrace=new Fulltrace();
	$rebres=new Rebres();
	$info=new Info();
	$cdr=new Cdr();
	$berofos=new Berofos();
    $br= new Back_res();


	$m=$_GET["m"];
	$f=$_GET["f"];

	

	//Das GET Parameter "m" bestimmt welches Modul angezeigt wird
	if ($m=="dialplan") { 
		print $e->display("m=dialplan,f=display,a=display");
	} elseif ($m=="sip") {
		print $sip->display("m=sip,f=display,a=display");
	} elseif ($m=="sipg") {
		print $sipg->display("m=sipg,f=display,a=display");
	} elseif ($m=="isdn-pri") {
		print $isdn->display("m=isdn,f=display,a=display");
	} elseif ($m=="isdn-bri") {
		print $isdn->display("m=isdn,f=display,a=display");
	} elseif ($m=="analog-fxs") {
		print $analog->display("m=analog,f=display,a=display");
	} elseif ($m=="analog-fxo") {
		print $analog->display("m=analog,f=display,a=display");
	} elseif ($m=="pstn_hw") {
		print $p_hw->display("m=pstn_hw,f=display,a=display");
	} elseif ($m=="net_conf") {
		print $net->display("m=net_conf,f=display,a=display");
	} elseif ($m=="time") {
		print $time->display("m=time,f=display,a=display");
	} elseif ($m=="back_res"){
		print $br->display("m=back_res,f=display,a=display");
	} elseif ($m=="ddebug") {
		print $ddebug->display("m=ddebug,f=display,a=display");
	} elseif ($m=="causes") {
		print $causes->display("m=causes,f=display,a=display");
	} elseif ($m=="callprogress") {
		print $callprogress->display("m=callprogress,f=display,a=display");
	} elseif ($m=="ftrace") {
		print $ftrace->display("m=ftrace,f=display,a=display");
	} elseif ($m=="rebres") {
		print $rebres->display("m=rebres,f=display,a=display");
	} elseif ($m=="info") {
		print $info->display("m=info,f=display,a=display");
	} elseif ($m=="cdr") {
		print $cdr->display("m=cdr,f=display,a=display");
	} elseif ($m=="state") {
		print $state->display("m=state,f=display,a=display");
	} elseif ($m=="remoteM") {
		print $remoteM->display("m=remoteM,f=display,a=display");
	} elseif ($m=="state_calls") {
		print $sc->display("m=state_calls,f=display,a=display");
	} elseif ($m=="state_statistic") {
		print $ss->display("m=state_statistic,f=display,a=display");
	//Wenn der GET Parameter "m" nicht gesetzt ist, wir das Modul "State" per default angezeigt
	} elseif (!$m) {
		print $state->display("m=state,f=display,a=display");
	} elseif ($m=="gen"){
		print $gen->display("m=gen,f=display,a=display");
	} elseif ($m=="sec"){
		print $sec->display("m=sec,f=display,a=display");
	} elseif ($m=="up_tool"){
		print $up_tool->display("m=up_tool,f=display,a=display");
	} elseif ($m=="prov"){
		print $prov->display("m=prov,f=display,a=display");
	} elseif ($m=="berofos"){
		print $berofos->display("m=berofos,f=display,a=display");
	}
	
	//Die Funktion action öffnet ein Popup für das Anlegen von neuen Einträgen
	if (($f=="action")&($m=="dialplan")) {
		print $e->action("m=dialplan,f=action,a=add");
	}elseif (($f=="action")&($m=="sip")){
		print $sip->action("m=sip,f=action,a=add");
	}elseif (($f=="action")&($m=="isdn-pri")){
		print $isdn->action("m=isdn,f=action,a=add");
	}elseif (($f=="action")&($m=="isdn-bri")){
		print $isdn->action("m=isdn,f=action,a=add");
	}elseif (($f=="action")&($m=="analog-fxs")){
		print $analog->action("m=analog,f=action,a=add");
	}elseif (($f=="action")&($m=="analog-fxo")){
		print $analog->action("m=analog,f=action,a=add");
	}
	
	/* Überprüfung ab eine Hardwareänderung stattgefunden hat,
	 * Der Benutzer wird durch eine Meldung darauf hingewiesen,
	 * dass ein Factory reset erforderlich ist
	 */
	
	$ba = new beroAri();
	$li0=exec('/bin/sed -ne "s/type: \(.*\)/\1/p" /proc/li0');
	$r_isdn=$ba->select("select distinct(type) from isdn where lif='0'");
	$r_analog=$ba->select("select distinct(type) from analog where lif='0'");
	$type_li0_isdn=sqlite_fetch_single($r_isdn);
	$type_li0_analog=sqlite_fetch_single($r_analog);
	if ($type_li0_isdn=="bf4S0" && $li0!="xhfc-4su"){
		print ("<script>document.getElementById('hardware_ch').innerHTML=\"".HARDWARE_CHANGED_DIS."\";</script>");
	}elseif($type_li0_isdn=="bf1E1" && $li0!="hfc-e1"){
		print ("<script>document.getElementById('hardware_ch').innerHTML=\"".HARDWARE_CHANGED_DIS."\";</script>");
	}elseif($type_li0_isdn=="bf2E1" && $li0!="hfc-2e1"){
		print ("<script>document.getElementById('hardware_ch').innerHTML=\"".HARDWARE_CHANGED_DIS."\";</script>");
	}elseif($type_li0_analog=="bf4FXS" && $li0!="si-4fxs"){
		print ("<script>document.getElementById('hardware_ch').innerHTML=\"".HARDWARE_CHANGED_DIS."\";</script>");
	}elseif($type_li0_analog=="bf4FXO" && $li0!="si-4fxo"){
		print ("<script>document.getElementById('hardware_ch').innerHTML=\"".HARDWARE_CHANGED_DIS."\";</script>");
	}elseif($type_li0_isdn=="bf2S02FXS" && $li0!="xhfcSi-2s02fxs"){
		print ("<script>document.getElementById('hardware_ch').innerHTML=\"".HARDWARE_CHANGED_DIS."\";</script>");
	}elseif (($type_li0_isdn=="" && $type_li0_analog=="") && $li0!="unknown"){
		print ("<script>document.getElementById('hardware_ch').innerHTML=\"".HARDWARE_CHANGED_DIS."\";</script>");
	}
	
	$revision=exec('sed -ne "s/.*revision=\(.*\)/\1/p" /proc/cmdline');
	$li0=exec('/bin/sed -ne "s/type: \(.*\)/\1/p" /proc/li0');
	$li1=exec('/bin/sed -ne "s/type: \(.*\)/\1/p" /proc/li1');
	if (($revision=="1.80" || $revision=="1.8") && ($li0=="xhfcSi-2s02fxs" || $li1=="xhfcSi-2s02fxs" || $li0=="si-4fxs" || $li1=="si-4fxs")){
		print ("<script>document.getElementById('hardware_ch').innerHTML+=\" ".HARDWARE_SUPPORT_DIS."\";</script>");
	}
	
	$li1=exec('/bin/sed -ne "s/type: \(.*\)/\1/p" /proc/li1');
	$r_isdn=$ba->select("select distinct(type) from isdn where lif='1'");
	$r_analog=$ba->select("select distinct(type) from analog where lif='1'");
	$type_li1_isdn=sqlite_fetch_single($r_isdn);
	$type_li1_analog=sqlite_fetch_single($r_analog);
	if ($type_li1_isdn=="bf4S0" && $li1!="xhfc-4su"){
		print ("<script>document.getElementById('hardware_ch').innerHTML=\"".HARDWARE_CHANGED_DIS."\";</script>");
	}elseif($type_li1_isdn=="bf1E1" && $li1!="hfc-e1"){
		print ("<script>document.getElementById('hardware_ch').innerHTML=\"".HARDWARE_CHANGED_DIS."\";</script>");
	}elseif($type_li1_isdn=="bf2E1" && $li1!="hfc-2e1"){
		print ("<script>document.getElementById('hardware_ch').innerHTML=\"".HARDWARE_CHANGED_DIS."\";</script>");
	}elseif($type_li1_analog=="bf4FXS" && $li1!="si-4fxs"){
		print ("<script>document.getElementById('hardware_ch').innerHTML=\"".HARDWARE_CHANGED_DIS."\";</script>");
	}elseif($type_li1_analog=="bf4FXO" && $li1!="si-4fxo"){
		print ("<script>document.getElementById('hardware_ch').innerHTML=\"".HARDWARE_CHANGED_DIS."\";</script>");
	}elseif($type_li1_isdn=="bf2S02FXS" && $li1!="xhfcSi-2s02fxs"){
		print ("<script>document.getElementById('hardware_ch').innerHTML=\"".HARDWARE_CHANGED_DIS."\";</script>");
	}elseif (($type_li1_isdn=="" && $type_li1_analog=="") && $li1!="unknown"){
		print ("<script>document.getElementById('hardware_ch').innerHTML=\"".HARDWARE_CHANGED_DIS."\";</script>");
	}

	
	if (exec("/bin/cat /proc/RESET_JUMPER")==1){	
		print ("<script>document.getElementById('reset_jumper').innerHTML='Reset jumper present. Please remove it after you have configured your network settings';</script>");
	}

//Karte oder Box neustarten
if ($_POST['v']=="Yes" && $_POST['action']=="reboot"){
/* 2 verschiedene Prozesse werden gestartet
 * der erste Prozess führt ein rcK aus,
 * der zweite Prozess wartet 10 Sekunden und wenn der rcK Prozess
 * nicht richtig beendet wurde, wird diese gestoppt und die Karte wird
 * neugestartet. Per AJAX wird geprüft ob die Karte wieder UP ist, das
 * Anmeldungfenster wird dann wieder angezeigt.
 */
$pid = pcntl_fork();

if($pid) {
  // this is the parent process
  // wait until the child has finished processing then end the script
  	sleep(10);
	print("<script type='text/javascript'>
	var req = false;
	function setRequest() {
	// Request erzeugen
		if (window.XMLHttpRequest) {
			req = new XMLHttpRequest(); // Mozilla, Safari, Opera
		} else if (window.ActiveXObject) {
			try {
				req = new ActiveXObject('Msxml2.XMLHTTP'); // IE 5
			} catch (e) {
				try {
					req = new ActiveXObject('Microsoft.XMLHTTP'); // IE 6
				} catch (e) {}
			}
		}


	// überprüfen, ob Request erzeugt wurde
	if (!req) {
		alert('Can not create an XMLHTTP instance');
		return false;
	} else {
		var url = 'index.php';
		// Request öffnen
		req.open('GET', url, true);
		// Requestheader senden
		// Request senden
		req.send(null);
		// Request auswerten
		req.onreadystatechange = interpretRequest;
	}
}

// Request auswerten
function interpretRequest() {
	switch (req.readyState) {
		// wenn der readyState 4 und der request.status 200 ist, dann ist alles korrekt gelaufen
		case 4:
			if (req.status != 200) {
				//Request senden solange die karte down ist.
				setRequest();
			} else {
				// Die karte wurde schon neugestartet
				window.location='./index.php';
			}
			break;
		default:
			break;
	}
}
window.setTimeout('setRequest()',5000);

</script>");
	exec('/usr/bin/killall rcK');
	exec ('/sbin/reboot');
	//sleep(10);
	//break;
	exit;
}

// the child process runs its stuff here and then ends
exec('/bin/sh /usr/local/init/rcK');

	
}

chdir("/usr/local/www/berogui");
require_once("./includes/footer.php");

//Prüfung ob die Session noch gültig ist. Wenn nicht wird der Benutzer darauf hingewiesen.
}elseif(($_SESSION['beroari_time'])&&(($_SESSION['beroari_time']+1200)<time())){
	
	include "./includes/variables.php";
	include "misc/database.php";
	$ba = new beroAri();
	require_once("./includes/lang.php");
	session_unset();
	session_destroy();
	print '<html><head><link rel="stylesheet" type="text/css" href="http:./includes/template_css.css" />';
	print "<title>beroAri</title></head><body>";
	
	print "<br><table align=\"center\" bgcolor=\"#f0f0ec\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\" width=\"500\">
	    <colgroup>
	    <col width=\"39\"></col>
	    </colgroup>
		<tbody><tr>
		<td colspan=\"2\"><img src=\"./includes/images/bg_top.png\"></td>
		</tr>
		<tr>
		<td background=\"./includes/images/bg_left.png\" style='background-repeat:repeat-y;' width=\"30\"><img src=\"./includes/images/trans.gif\" height=\"10\" width=\"39\"></td>
		<td><p align='left'><img src=\"./includes/images/berofixlogo.png\"/></p><center><hr size= \"1\" noshade>";

	echo SESSION_EXPIRED."<br>";
	echo $_SESSION['beroari_time']."<br>";
	echo '<a href="./includes/login.php">'.LOGIN.'</a>';

	print "<hr size= \"1\" noshade><br/>
	<table align='right'>
	<tr><td>
	<a href='http://wiki.beronet.com/' id='help'><img src='".IMAGE_HELP."' onmouseover=\"this.src='".IMAGE_HELP_HOVER."'\" onmouseout=\"this.src='".IMAGE_HELP."';\"/></a>
	</td>
	</tr>
	<tr>
	<td>
	<a href=\"http://www.beronet.com\" target=\"_blank\" onfocus=\"if (this.blur()) { this.blur(); }\">
	<img src=\"./includes/images/beroLogo.gif\" align=\"right\" border=\"0\">
	</a>
	</td>
	</tr>
	</table>";
	print "</center></td></tr>
		<tr>
		<td colspan=\"2\" style=\"background-repeat:no-repeat\" background=\"./includes/images/bg_bottom.png\">
		<img src=\"./includes/images/trans.gif\" border=\"0\" height=\"39\" width=\"10\">
		<div style=\"color: white;\" align=\"right\">" . APPVERSION . "&nbsp;&nbsp;&nbsp;</div>
		</td></tr>";
	print "</body></html>";
}else{
	print "<SCRIPT LANGUAGE='javascript'> location.href = './includes/login.php?m=sip';</SCRIPT><br>";

}

?>
